var prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
var addressbookFitSMSSortBy;

function FitSMS_AddressBook_Sort(a, b) {
	
	var piecesA = a.split(".ITEM.");
	var piecesB = b.split(".ITEM.");
	
	var c1 = piecesA[1];
	var c2 = piecesB[1];
	if ( addressbookFitSMSSortBy == "prename" ) {
		c1 = piecesA[0];
		c2 = piecesB[0];
	} else if ( addressbookFitSMSSortBy == "mobile" ) {
		c1 = piecesA[2];
		c2 = piecesB[2];
	}
	
	
	if ( c1 > c2 ) {
		return 1;
	} else if ( c1 < c2 ) {
		return -1;
	}
	return 0;
	
}

function FitSMS_AddressBook_PopulateList() {
	
	var prefString = prefManager.getCharPref("extensions.fitsms.addressbook");
	if ( prefString == "" )
		return;
	
	prefString = decodeURIComponent(prefString);
	var entries = prefString.split(".NEXT.");
	var fSortBy = document.getElementById("FitSMS-AdressBook-SortBy");
	var treeList = document.getElementById("FitSMS-AdressBook-Tree-List");
	
	addressbookFitSMSSortBy = fSortBy.value;
	entries.sort(FitSMS_AddressBook_Sort);
	
	for (var i = treeList.childNodes.length; i > 0; i--) {		
		var toRemove = treeList.childNodes.item(i-1);
		treeList.removeChild(toRemove);
	}	

	for (var i = 0; i < entries.length; i++) {
		var pieces = entries[i].split(".ITEM.");

		var newItem = document.createElement("treeitem");
		var newRow = document.createElement("treerow");
		newItem.appendChild(newRow);

		var abPrename = document.createElement("treecell");
		abPrename.setAttribute("label", pieces[0]);
		newRow.appendChild(abPrename);

		var abSurname = document.createElement("treecell");
		abSurname.setAttribute("label", pieces[1]);
		newRow.appendChild(abSurname);
		
		var abMobile = document.createElement("treecell");
		abMobile.setAttribute("label", pieces[2]);
		newRow.appendChild(abMobile);

		treeList.appendChild(newItem);
	}
	
	document.getElementById("FitSMS-AddressBook-Pane").userChangedValue(addressbookTree);
	
}

function FitSMS_AddressBook_SaveList() {
	
	var treeList = document.getElementById("FitSMS-AdressBook-Tree-List").childNodes;
	var prefString = "";
	for (var i = 0; i < treeList.length; i++) {
		
		var columns = treeList[i].childNodes[0].childNodes;
		var str = columns[0].getAttribute("label") + ".ITEM." + columns[1].getAttribute("label") + ".ITEM." + columns[2].getAttribute("label");
		if ( prefString == "" ) {
			prefString = str;
		} else {
			prefString += ".NEXT." + str;
		}
		
	}
	return encodeURIComponent(prefString);
	
}

function FitSMS_AddressBook_PopulateEdit(prename, surname, mobile, editIndexStr) {
	
	var fPrename = document.getElementById("FitSMS-AdressBook-CreateEdit-Prename");
	var fSurname = document.getElementById("FitSMS-AdressBook-CreateEdit-Surname");
	var fMobile = document.getElementById("FitSMS-AdressBook-CreateEdit-Mobile");
	var editIndex = document.getElementById("FitSMS-AdressBook-CreateEdit-Index");	

	editIndex.value = "" + editIndexStr;

	fPrename.value = prename;
	fSurname.value = surname;
	fMobile.value = mobile;
	
	fPrename.focus();
	
}

function FitSMS_AddressBook_Entry_Edit() {
	
	var addressbookTree = document.getElementById("FitSMS-AdressBook-Tree");
	var selectedIndex = addressbookTree.currentIndex;
	
	if (selectedIndex == -1)
		return;

	var treeList = document.getElementById("FitSMS-AdressBook-Tree-List");
	var entry = treeList.childNodes[selectedIndex].childNodes[0].childNodes;

	FitSMS_AddressBook_FlipView("edit");
	FitSMS_AddressBook_PopulateEdit(entry[0].getAttribute("label"), entry[1].getAttribute("label"), entry[2].getAttribute("label"), selectedIndex);
	
}

function FitSMS_AddressBook_Entry_Delete() {
	
	var addressbookTree = document.getElementById("FitSMS-AdressBook-Tree");
	var index = addressbookTree.currentIndex;

	if (index != -1) {
		var treeList = document.getElementById("FitSMS-AdressBook-Tree-List");
		var toRemove = treeList.childNodes.item(index);
		treeList.removeChild(toRemove);
		document.getElementById("FitSMS-AddressBook-Pane").userChangedValue(addressbookTree);
	}
	
}

function FitSMS_AddressBook_FlipView(mode) {
	
	var addressBookBoxList = document.getElementById("FitSMS-AdressBook-Box-List-Outer");
	var addressBookBoxCreateEdit = document.getElementById("FitSMS-AdressBook-Box-CreateEdit-Outer");

	if (mode == "edit") {
		addressBookBoxList.setAttribute("hidden", "true");
		addressBookBoxCreateEdit.setAttribute("hidden", "false");
	} else {
		addressBookBoxList.setAttribute("hidden", "false");
		addressBookBoxCreateEdit.setAttribute("hidden", "true");
	}
	
}

function FitSMS_AddressBook_Entry_New() {
	
	FitSMS_AddressBook_FlipView("edit");
	FitSMS_AddressBook_PopulateEdit("", "", "", "");
	
}

function FitSMS_AddressBook_Entry_CreateEdit_Save() {
	
	var fPrename = document.getElementById("FitSMS-AdressBook-CreateEdit-Prename");
	var fSurname = document.getElementById("FitSMS-AdressBook-CreateEdit-Surname");
	var fMobile = document.getElementById("FitSMS-AdressBook-CreateEdit-Mobile");	
	var editIndex = document.getElementById("FitSMS-AdressBook-CreateEdit-Index");	
	var treeList = document.getElementById("FitSMS-AdressBook-Tree-List");
	
	var nummer = FitSMS_TrimString(fMobile.value);
	if( nummer.length == 0 ) {
		alert("Bitte geben Sie die Handynummer ein.");
		return;
	} else {
		nummer = FitSMS_FormatMobileNumber(nummer);
		if (nummer.length == 0) {
			return;
		} else {
			fMobile.value = nummer;
		}
	}

	var newRow = document.createElement("treerow");
	var newItem = document.createElement("treeitem");
	newItem.appendChild(newRow);

	var prename = document.createElement("treecell");
	prename.setAttribute("label", FitSMS_TrimString(fPrename.value));
	newRow.appendChild(prename);

	var surname = document.createElement("treecell");
	surname.setAttribute("label", FitSMS_TrimString(fSurname.value));
	newRow.appendChild(surname);
	
	var mobile = document.createElement("treecell");
	mobile.setAttribute("label", FitSMS_TrimString(fMobile.value));
	newRow.appendChild(mobile);
	
	if (editIndex.value == "") {
		treeList.appendChild(newItem);
	} else {
		var oldItem = treeList.childNodes[parseInt(editIndex.value)];
		treeList.replaceChild(newItem, oldItem);
	}

	var addressbookTree = document.getElementById("FitSMS-AdressBook-Tree");
	document.getElementById("FitSMS-AddressBook-Pane").userChangedValue(addressbookTree);

	FitSMS_AddressBook_FlipView("normal");
	
}

function FitSMS_AddressBook_Entry_CreateEdit_Cancel() {
	
	FitSMS_AddressBook_FlipView("normal");
	
}

function FitSMS_AddressBook_Entry_CreateEdit_Mobile_Blur(event) {
	
	var formFieldMobile = document.getElementById("FitSMS-AdressBook-CreateEdit-Mobile");
		
	var nummer = FitSMS_TrimString(formFieldMobile.value);
	if ( nummer.length > 0 ) {
		nummer = FitSMS_FormatMobileNumber(nummer);
		if (nummer.length == 0) {
			alert("Die von Ihnen eingegebene Mobilfunk-Nummer ist ungültig.");
		} else {
			formFieldMobile.value = nummer;
		}
	}
	
}

function FitSMS_AddressBook_Label_Prename() {
	
	FitSMS_AddressBook_List_SortBy("prename");
	
}

function FitSMS_AddressBook_Label_Surname() {
	
	FitSMS_AddressBook_List_SortBy("surname");
	
}

function FitSMS_AddressBook_Label_Mobile() {
	
	FitSMS_AddressBook_List_SortBy("mobile");
	
}

function FitSMS_AddressBook_List_SortBy(sortBy) {
	
	var fSortBy = document.getElementById("FitSMS-AdressBook-SortBy");
	fSortBy.value = sortBy;
	FitSMS_AddressBook_PopulateList();
	
}

function FitSMS_AddressBook_List_Element(event) {
	
	var addressbookTree = document.getElementById("FitSMS-AdressBook-Tree");
	if ( addressbookTree.view.selection.getRangeCount() > 0 ) {
		var prefWindow = document.getElementById("FitSMS-AddressBook");
		prefWindow.acceptDialog();
	}
	
}

function FitSMS_AddressBook_AcceptDialog(event) {
	
	var addressbookTree = document.getElementById("FitSMS-AdressBook-Tree");
	var treeList = document.getElementById("FitSMS-AdressBook-Tree-List");
	var rcps = '';
	
	// get all selected items (multiple selection possible)
	var start = new Object();
	var end = new Object();
	var numRanges = addressbookTree.view.selection.getRangeCount();
	for (var t = 0; t < numRanges; t++) {
		addressbookTree.view.selection.getRangeAt(t, start, end);
		for (var v = start.value; v <= end.value; v++) {
			var entry = treeList.childNodes[v].childNodes[0].childNodes;
			if ( rcps != '' ) {
				rcps += ',';
			}
			rcps += entry[2].getAttribute("label");
		}
	}
	
	var fRecipients = opener.document.getElementById("FitSMS-Recipients");
	fRecipients.value = rcps;
	fRecipients.focus();
	
}
